blt.xaudio.setup()


--- var -----
NowPlayMusic = nil
isInCar = false
musicTime = 0
AllOggFile = {}
sec = 0
------------------------

local peer = managers.network and managers.network:session() or nil
peer = peer and peer:local_peer() or nil

------------------------


---------read ogg file------------------
function loadmusic(path)
    local oggfiles = file.GetFiles(path)
    for _,oggfile in pairs(oggfiles) do
        if string.match(oggfile, "%.ogg$") then
            local data = {
                name = tostring(string.gsub(oggfile, "%.ogg$", "")),
                buffer = XAudio.Buffer:new(path .. oggfile)
            }
            table.insert(AllOggFile, data)
        end
    end
end

loadmusic(BLTModManager.Constants.mods_directory .."carmusic/sound/")


function playCarMusic()
    math.randomseed(tostring(os.time()):reverse():sub(1, 6))
    randomOgg = math.random(1, #AllOggFile)
    NowPlayMusic = XAudio.Source:new(AllOggFile[randomOgg].buffer)
	NowPlayMusic:set_volume(1)
    managers.chat:send_message(1, peer, 'Nowplaying：' .. AllOggFile[randomOgg].name)
end



--------------delaycall---------------------
function modTick(sec)
    if isInCar and NowPlayMusic:is_closed() then
        playCarMusic()
    end
end


Hooks:PostHook(HUDManager, "update", "musicupdata",function(self, t, dt)
    if Utils:IsInHeist() then
        sec = sec + tonumber(dt)
        if sec > 1 then
            modTick(sec)
            sec = 0
        end
    end
end)

--------------------------------------

Hooks:PostHook(HUDDriving, "start", "playmusic",function(self)
    playCarMusic()
    isInCar = true
end)


Hooks:PostHook(HUDDriving, "stop", "stopmusic",function(self)
    NowPlayMusic:close(true)
    managers.chat:send_message(1, peer, 'Pause')
    isInCar = false
end)


